/**
 * @file
 *
 * Javascript functionalities for the search bar in a block.
 */
(function ($, Drupal, drupalSettings) {

  Drupal.behaviors.pp_graphsearch_block_search_bar = {
    attach: function (context, settings) {
      $("div.pp-graphsearch-block-search-bar", context).once('pp_graphsearch_block_search_bar').each(function () {

        var input = $("input", this);

        // Search for free terms.
        //var search_types = input.data("search-type").split(" ");
        var search_types = drupalSettings.pp_graphsearch.search_type.split(" ");
        $(this).closest("form").submit(function (event) {
          // Check if searching for free terms is activated.
          if ($.inArray("free-term", search_types) !== -1) {
            window.location.href = drupalSettings.path.baseUrl.substr(0, -1) + drupalSettings.pp_graphsearch.page_path + '?search=' + input.val();
          }
          event.preventDefault();
        });

        // Clear the input field on focus.
        input.focus(function() {
          input.val("");
        });

        // Add the autocomplete functionality to the input field.
        /*input.autocomplete({
          minLength: input.data("min-chars"),
          source: function (request, response) {
            var url = Drupal.settings.basePath + input.data("autocomplete-path");
            $.getJSON(url, {term: request.term}, function (data) {
              input.removeClass("throbbing");
              response(data);
            });
          },
          search: function (event, ui) {
            input.addClass("throbbing");
            console.log('bing');
          },
          focus: function (event, ui) {
            this.value = ui.item.label;
            return false;
          },
          select: function (event, ui) {
            this.value = ui.item.label;
            window.location.href = Drupal.settings.basePath + input.data("page-path") + '?uri=' + ui.item.value;
            return false;
          }
        });*/



        // Set click event for search bar submit button.
        /*search_bar_form.find(".search-bar-submit").once("pp-graphsearch").each(function() {
          $(this).click(function(event) {
            event.preventDefault();
            if (facetBox.isEmptyCache()) {
              var search_bar_text = search_bar_form.find("input.form-text");
              var value = search_bar_text.val();
              var facet = {
                type: "free-term",
                field: "dyn_txt_content",
                value: value.trim(),
                label: value.trim()
              };
              search_bar_text.autocomplete("close").val("");
            }
            else {
              facet = facetBox.getCache();
              facetBox.clearCache();
            }
            if (facet.label !== "") {
              facetBox.add(facet);
            }
          });
        });*/

        // Set focus event for the search bar text field.
        //search_bar_form.find("input.form-text").once("pp-graphsearch").each(function() {
          /*$(this).focus(function() {
            $(this).val("");
          });*/

        input.on('autocompleteselect', function(event, ui) {
          event.preventDefault();
          this.value = ui.item.label;
          var data = ui.item.value.split("|");
          window.location.href = drupalSettings.path.baseUrl.substr(0, -1) + drupalSettings.pp_graphsearch.page_path + '?uri=' + data[1];
          return false;
        });

        input.on('autocompleteclose', function(event, ui) {
          $(this).val("");
        });

        input.autocomplete( "option", "minLength", drupalSettings.pp_graphsearch.min_chars);
        //});
      });

    }
  };

})(jQuery, Drupal, drupalSettings);
